SPOOL H:\output.txt
SET SQLFORMAT DEFAULT
set echo on
ALTER SESSION SET NLS_DATE_FORMAT = 'YYYYMMDD';
set verify off
set pagesize 200
set linesize 200

DROP TABLE "MYUSER"."A_RKB_SQLCL_COL_TST";
CREATE TABLE "MYUSER"."A_RKB_SQLCL_COL_TST" 
( ID     NUMBER(9) NOT NULL,
  ONE_DT DATE,
  TWO_DT DATE,
  LST_CD CHAR(1)
 )
 TABLESPACE "MYUSER"
 PCTUSED    40
 PCTFREE    10
 INITRANS   1
 MAXTRANS   255
 STORAGE(
  INITIAL          32K
  NEXT             32K
  MINEXTENTS       1
  MAXEXTENTS       UNLIMITED
  PCTINCREASE      0
  FREELISTS        1
  FREELIST GROUPS  1
  BUFFER_POOL      DEFAULT
  FLASH_CACHE      DEFAULT
  CELL_FLASH_CACHE DEFAULT
 ) 
 NOCOMPRESS 
 NOCACHE
 NOPARALLEL
 MONITORING;
INSERT INTO "MYUSER"."A_RKB_SQLCL_COL_TST" (ID, ONE_DT, TWO_DT, LST_CD) VALUES (123456780, TO_DATE('20210623', 'YYYYMMDD'), NULL, 'A');
INSERT INTO "MYUSER"."A_RKB_SQLCL_COL_TST" (ID, ONE_DT, TWO_DT, LST_CD) VALUES (123456781, TO_DATE('20210624', 'YYYYMMDD'), TO_DATE('20220624', 'YYYYMMDD'), 'B');
INSERT INTO "MYUSER"."A_RKB_SQLCL_COL_TST" (ID, ONE_DT, TWO_DT, LST_CD) VALUES (123456782, TO_DATE('20210625', 'YYYYMMDD'), TO_DATE('20220625', 'YYYYMMDD'), 'C');
INSERT INTO "MYUSER"."A_RKB_SQLCL_COL_TST" (ID, ONE_DT, TWO_DT, LST_CD) VALUES (123456783, TO_DATE('20210626', 'YYYYMMDD'), TO_DATE('20220626', 'YYYYMMDD'), 'D');
INSERT INTO "MYUSER"."A_RKB_SQLCL_COL_TST" (ID, ONE_DT, TWO_DT, LST_CD) VALUES (123456784, TO_DATE('20210627', 'YYYYMMDD'), TO_DATE('20220627', 'YYYYMMDD'), 'E');
COMMIT;

-- NULLS LAST: Works on both SQLPlus and SQLcl
SELECT ID, ONE_DT, TWO_DT, LST_CD FROM A_RKB_SQLCL_COL_TST ORDER BY TWO_DT NULLS LAST;

-- NULLS FIRST: Works on SQLPlus, not on SQLcl (TWO_DT width is too long)
SELECT ID, ONE_DT, TWO_DT, LST_CD FROM A_RKB_SQLCL_COL_TST ORDER BY TWO_DT NULLS FIRST;

-- Try with set null to ^
set null '^'

-- NULLS LAST: Works on both SQLPlus and SQLcl
SELECT ID, ONE_DT, TWO_DT, LST_CD FROM A_RKB_SQLCL_COL_TST ORDER BY TWO_DT NULLS LAST;

-- NULLS FIRST: Works on SQLPlus, not on SQLcl (TWO_DT width is one byte too short)
SELECT ID, ONE_DT, TWO_DT, LST_CD FROM A_RKB_SQLCL_COL_TST ORDER BY TWO_DT NULLS FIRST;

-- Works if explicitly set the column width
column TWO_DT format a8

-- NULLS LAST: Works on both SQLPlus and SQLcl with format a8
SELECT ID, ONE_DT, TWO_DT, LST_CD FROM A_RKB_SQLCL_COL_TST ORDER BY TWO_DT NULLS LAST;

-- NULLS FIRST: Works on both SQLPlus and SQLcl with format a8
SELECT ID, ONE_DT, TWO_DT, LST_CD FROM A_RKB_SQLCL_COL_TST ORDER BY TWO_DT NULLS FIRST;

SPOOL OFF
